#include <iostream>
#include <stdio.h>
#include <stack>
#include "Multiply.h"
#include "Add.h"
#include "Subtract.h"

using namespace std;

#define mu_assert(message, test) do { if (!(test)) return message; } while (0)
#define mu_run_test(test) do { string message = (test); tests_run++; \
                               if (!message.empty()) return message; } while (0)
int tests_run;

typedef int type_unary;

static string test_result(FunctionCompositor<type_unary> &comp, int val, int res) {
    char tmpStr[1024];
    sprintf(tmpStr, "error, comp(%d) != %d", val, res);
    string str(tmpStr);
    mu_assert(str, comp(val) == res);
    return string();
 }

 static string all_tests(FunctionCompositor<type_unary> &comp) {
     mu_run_test(test_result(comp, 0, -9));
     mu_run_test(test_result(comp, 1, -7));
     mu_run_test(test_result(comp, 2, -5));
     return string();
 }

int main()
{
    // TODO: Unsigned int specializations do not check for overflows

    // Single value result
    /*type_unary partial = 0;
    FunctionCompositor<type_unary> comp;
    comp.appendFunction(new Multiply<type_unary>(2));
    comp.appendFunction(new Subtract<type_unary>(10));
    comp.appendFunction(new Add<type_unary>(1));
    cout << comp(partial) << endl;
    return 0;*/

    // Array result
    /*const int N = 3;
    type_unary partial[N] = {0, 1, 2};
    FunctionCompositor<type_unary*, N> comp;
    comp.appendFunction(new Multiply<type_unary>(2));
    comp.appendFunction(new Subtract<type_unary>(10));
    comp.appendFunction(new Add<type_unary>(1));

    comp(partial); // Modifies the partial array and returns the pointer to that array
    for(int i = 0; i < N; i++)
        cout << partial[i] << endl;
    return 0;*/


    // Unit testing result
    FunctionCompositor<type_unary> comp;
    comp.appendFunction(new Multiply<type_unary>(2));
    comp.appendFunction(new Subtract<type_unary>(10));
    comp.appendFunction(new Add<type_unary>(1));
    string result = all_tests(comp);
    if(!result.empty())
         cout << result << endl;
    else
         cout << "ALL TESTS PASSED" << endl;
    cout << "Tests run: " << tests_run << endl;

    return !result.empty();

}
